#!/usr/bin/haserl
Content-Type: text/xml

<%
. /www/cgi-bin/switches/en.lng
#. /www/cgi-bin/switches/fr.lng

lockfile=/var/lock/i2c.lck
config_file=/etc/domus/switches.conf
xmlfoot="</switchesXml>"
delay=3

adieu() {
 echo -n "<errorMsg>"
 [ $debug ] && echo -n $dbg_msg || echo -n $std_msg
 echo -n "</errorMsg>"
 echo -n "$xmlfoot"
 exit 1
}

echo -n "<?xml version=\"1.0\" encoding=\"UTF-8\"?><switchesXml>"

std_msg=$std_msg10
# test des variables de l'URL
[ $GET_d ] && debug="y" || debug=""

if [ $GET_op ]; then
 op=$GET_op
 case "$op" in
  config)
  ;;
  control)
   need_ac="yes"
   need_li="yes"
  ;;
  *)
   dbg_msg=$dbg_msg10
   adieu
  ;;
 esac
else
 dbg_msg=$dbg_msg20
 adieu
fi

if [ $GET_pa ]; then
 port=$GET_pa
 case $port in
  0x20|0x21|0x22|0x23)
  ;;
  *)
  dbg_msg=$dbg_msg30
  adieu
  ;;
 esac
else
 dbg_msg=$dbg_msg40
 adieu
fi

if [ $need_ac ]; then
 if [ $GET_ac ]; then
  action=$GET_ac
  case "$action" in
   on|off)
   ;;
   reboot)
   need_delay="yes"
   ;;
   *)
   dbg_msg=$dbg_msg50
   adieu
   ;;
  esac
 else
  dbg_msg=$dbg_msg60
  adieu
 fi
fi

if [ $need_li ]; then
 if [ $GET_li ]; then
  line=$GET_li
  case $line in
   0|1|2|3|4|5|6|7)
   ;;
   *)
   dbg_msg=$dbg_msg70
   adieu
   ;;
  esac
 else
  dbg_msg=$dbg_msg80
  adieu
 fi
fi

if [ $need_delay ]; then
 if [ $GET_tr ]; then
  tested_delay=`echo $GET_tr|grep -E '^[0-9]{1,2}$'`
  if [ $tested_delay ]; then
   delay=$tested_delay
  fi
 fi
fi

# execution de l'opération
case "$op" in
 config)
  portconfig=`cat $config_file|grep "^$port"`
  echo "<switchConfig>"
  for i in 0 1 2 3 4 5 6 7 
   do
    io=`echo "$portconfig"|grep "^$port\;$i\;"`
    name=`echo "$io"|cut -d';' -f3`
    echo "<name$i>$name</name$i>"
    icon=`echo "$io"|cut -d';' -f4`
    echo "<icon$i>$icon</icon$i>"
    startpos=`echo "$io"|cut -d';' -f5`
    echo "<startPos$i>$startpos</startPos$i>"
    options=`echo "$io"|cut -d';' -f6`
    actallow=`echo "$options"|grep -Eo "no_all"`
    if [ $actallow ]; then
     echo "<button_on$i>hidden</button_on$i>"
     echo "<button_off$i>hidden</button_off$i>"
     echo "<button_reboot$i>hidden</button_reboot$i>"
    else
     actallow=`echo "$options"|grep -Eo "no_on"`
     if [ $actallow ]; then
      echo "<button_on$i>hidden</button_on$i>"
     else
      echo "<button_on$i>visible</button_on$i>"
     fi
     actallow=`echo "$options"|grep -Eo "no_off"`
     if [ $actallow ]; then
      echo "<button_off$i>hidden</button_off$i>"
     else
      echo "<button_off$i>visible</button_off$i>"
     fi
     actallow=`echo "$options"|grep -Eo "no_reboot"`
     if [ $actallow ]; then
      echo "<button_reboot$i>hidden</button_reboot$i>"
     else
      echo "<button_reboot$i>visible</button_reboot$i>"
     fi
    fi
   done
  echo "</switchConfig>"
  ;;
 control)
  # lecture config ligne concernee
  std_msg=$std_msg20
  result=`cat $config_file|grep "^$port\;$line\;"`
  if [ $result ]; then
   options=`echo "$result"|cut -d';' -f6`
  else
   dbg_msg="$port/$line $dbg_msg90"
   adieu
  fi
  tstall=`echo "$options"|grep -Eo "no_all"`
  tston=`echo "$options"|grep -Eo "no_on"`
  tstoff=`echo "$options"|grep -Eo "no_off"`
  tstreboot=`echo "$options"|grep -Eo "no_reboot"`
  # avons nous le droit de faire l'action ?
  std_msg=$std_msg30
  actallow=`echo "$options"|grep -Eo "no_$action"`
  if [ $actallow ]; then
   dbg_msg="$port/$line : $actallow"
   adieu
  fi
  actallow=`echo "$options"|grep -Eo "no_all"`
  if [ $actallow ]; then
   dbg_msg="$port/$line : $actallow"
   adieu
  fi
  # test lock file || lock
  std_msg=$std_msg40
  if [ -f $lockfile ]; then
   sleep 2
   if [ -f $lockfile ]; then
    dbg_msg=$dbg_msg100
    adieu
   fi
  else
   touch $lockfile
  fi
  # lecture du port
  hex=`i2cget -y 0 $port|cut -f2 -d'x'|tr "[a-z]" "[A-Z]"`
  dec=`echo "obase=10;ibase=16;$hex"|bc`
  old=`echo "0x$hex"`
  laststate=$old
  # etat du bit a modifier
  val=$dec;count=0
  while [ $count -le $line ]; do
   bitval=$(expr $val % 2)
   tmp1=$(expr $val - $bitval)
   tmp2=$(expr $tmp1 / 2)
   val=$tmp2
   let count=count+1 
  done
# faire l'action
  std_msg=$std_msg50
  case $action in
   on)
    if [ $bitval -eq 1 ]; then
     newhex=`echo "obase=16;ibase=10;$dec-(2^$line)"|bc`
     newdec=`echo "obase=10;ibase=16;$newhex"|bc`
     new=`echo "0x$newhex"`
     ret=`i2cset -y 0 $port $new $new`
     newstathex=`i2cget -y 0 $port|cut -f2 -d'x'|tr "[a-z]" "[A-Z]"`
     newstatdec=`echo "obase=10;ibase=16;$newstathex"|bc`
     if [ $newdec -eq $newstatdec ]; then
      laststate=$new
      dbg_msg="$port/$line $action : OK"
     else
      dbg_msg="$port/$line $action, $dbg_msg110"
      rm -f $lockfile
      adieu
     fi
    else
     dbg_msg="$port/$line $dbg_msg120"
     rm -f $lockfile
     adieu
    fi
   ;;
   off)
    if [ $bitval -eq 0 ]; then
     newhex=`echo "obase=16;ibase=10;$dec+(2^$line)"|bc`
     newdec=`echo "obase=10;ibase=16;$newhex"|bc`
     new=`echo "0x$newhex"`
     ret=`i2cset -y 0 $port $new $new`
     newstathex=`i2cget -y 0 $port|cut -f2 -d'x'|tr "[a-z]" "[A-Z]"`
     newstatdec=`echo "obase=10;ibase=16;$newstathex"|bc`
     if [ $newdec -eq $newstatdec ]; then
      laststate=$new
      dbg_msg="$port/$line $action : OK"
     else
      dbg_msg="$port/$line $action, $dbg_msg130"
      rm -f $lockfile
      adieu
     fi
    else
     dbg_msg="$port/$line $dbg_msg140"
     rm -f $lockfile
     adieu
    fi
   ;;
   reboot)
    if [ $bitval -eq 0 ]; then
     newhex=`echo "obase=16;ibase=10;$dec+(2^$line)"|bc`
     newdec=`echo "obase=10;ibase=16;$newhex"|bc`
     new=`echo "0x$newhex"`
     ret=`i2cset -y 0 $port $new $new`
     newstathex=`i2cget -y 0 $port|cut -f2 -d'x'|tr "[a-z]" "[A-Z]"`
     newstatdec=`echo "obase=10;ibase=16;$newstathex"|bc`
     if [ $newdec -eq $newstatdec ]; then
      sleep $delay
      ret=`i2cset -y 0 $port $old $old`
      oldstathex=`i2cget -y 0 $port|cut -f2 -d'x'|tr "[a-z]" "[A-Z]"`
      oldstatdec=`echo "obase=10;ibase=16;$oldstathex"|bc`
      if [ $dec -eq $oldstatdec ]; then
       dbg_msg="$port/$line $action : OK"
      else
       dbg_msg="$port/$line $action, $dbg_msg150"
       rm -f $lockfile
       adieu
      fi
     else
      dbg_msg="$port/$line $action, $dbg_msg160"
      rm -f $lockfile
      adieu
     fi
    else
     dbg_msg="$port/$line $dbg_msg170"
     rm -f $lockfile
     adieu
    fi
   ;;
  esac

  echo -n "$laststate" > /etc/domus/$port.lst

  if [ $tstall ]; then
   echo "<button_on$line>hidden</button_on$line>"
   echo "<button_off$line>hidden</button_off$line>"
   echo "<button_reboot$line>hidden</button_reboot$line>"
  else
   if [ $tston ]; then
    echo "<button_on$line>hidden</button_on$line>"
   else
    echo "<button_on$line>visible</button_on$line>"
   fi
   if [ $tstoff ]; then
    echo "<button_off$line>hidden</button_off$line>"
   else
    echo "<button_off$line>visible</button_off$line>"
   fi
   if [ $tstreboot ]; then
    echo "<button_reboot$line>hidden</button_reboot$line>"
   else
    echo "<button_reboot$line>visible</button_reboot$line>"
   fi
  fi
  std_msg=$std_msg60
  echo -n "<actionStatus>"
  [ $debug ] && echo -n $dbg_msg || echo -n $std_msg
  echo -n "</actionStatus>"
  rm -f $lockfile
 ;;
 *)
  dbg_msg=$dbg_msg180
  adieu
 ;;
esac

statusHex=`i2cget -y 0 $port|cut -f2 -d'x'| tr "[a-z]" "[A-Z]"`
statusDec=`echo "obase=10;ibase=16;$statusHex" | bc`
echo "<switchStatus>"
 val=$statusDec
 for i in 0 1 2 3 4 5 6 7 
  do
   mod=$(expr $val % 2)
   echo "<D$i>$mod</D$i>"
   new1=$(expr $val - $mod)
   new=$(expr $new1 / 2)
   val=$new
  done
 echo "</switchStatus>"
echo -n "$xmlfoot"

%>
